$MODID51
$INCLUDE(MACROS51)

	SELECT NONE	
	COMMAND #01H
		
	MOV R1, #11
	MOV R2, #59
	MOV R3, #50

	MOV R4, #02
	MOV R5, #00
	MOV R6, #12

MAIN:
	
	ACALL THESETTIME
	ACALL THESETALM
	ACALL THESETALMOFF
	
THELOOP:
	COMMAND #80H
	ACALL THEDISPTIME	
	ACALL SECONDALMCHK
	ACALL THEINCTIMER
	SJMP  THELOOP	
	

THESETTIME:
	MOV SS,R3
	MOV MM,R2
	MOV HH,R1
RET


THEDISPTIME:
	DISPCH #'T'
	DISPCH #'I'
	DISPCH #'M'
	DISPCH #'E'
	DISPCH #':'
	DISPCH #' '

	MOV R3,HH
	MOV A,R3
	ACALL THEDISPDEC

	DISPCH #':'
	MOV R3,MM
	MOV A,R3
	ACALL THEDISPDEC
	DISPCH #':'
	MOV R3,SS
	MOV A,R3
	ACALL THEDISPDEC

RET


THEDISPDEC:

	MOV	B, #10
	DIV	AB

	ADD	A, #30H
	DISPCH	A

	MOV	A, B
	ADD	A, #30H
	DISPCH	A

RET

THESETALM:
	MOV ALMSS,R4
	MOV ALMMM,R5
	MOV ALMHH,R6

RET

THEINCTIMER:
	MOV R2,#59
	MOV A,R2
	CJNE A,SS,L1
	MOV SS,#0	
	CJNE A,MM,L2
	MOV MM,#0	
	MOV A,#24
	CJNE A,HH,L3
	MOV HH,#0
	

L1:
	MOV R6,SS
	INC R6
	MOV SS,R6
	ACALL THEDELAY
	SJMP L4	
L2:

	MOV R6,MM
	INC R6
	MOV MM,R6
	ACALL THEDELAY
	MOV MM,#0
	SJMP L4	
L3:
	MOV R6,HH
	INC R6
	MOV HH,R6
	ACALL THEDELAY
	SJMP L4	

L4:
RET

THESETALMOFF:
	MOV ALMSSOFF,#12
	MOV ALMMMOFF,#0
	MOV ALMHHOFF,#12

RET

THEDELAY:
	MOV	R0, #10
M1:
	MOV	TMOD, #01H
	MOV	TL0, #0FDH
	MOV	TH0, #4BH
	
	SETB	TR0
AGAIN1:
	JNB	TF0, AGAIN1
	CLR	TR0
	CLR	TF0
	DJNZ	R0, M1
RET

THEALMCHK:	
	MOV R5,ALMSS
	MOV A,R5
	CJNE A,SS,C1

	MOV R5,ALMMM
	MOV A,R5
	CJNE A,MM,C1

	MOV R5,ALMHH
	MOV A,R5
	CJNE A,HH,C1

	SNDON
C1:	

	MOV R6,ALMSSOFF
	MOV A,R6
	CJNE A,SS,C2

	MOV R6,ALMMMOFF
	MOV A,R6	
	CJNE A,MM,C2

	MOV R6,ALMHHOFF
	MOV A,R6	
	CJNE A,HH,C2
	SNDOFF	
	
C2:
RET
RETURN:
RET

SECONDALMCHK:	
    MOV A,HH	
    CLR C	
    SUBB A,ALMHH
    JC RETURN

    MOV A,ALMHHOFF	
    CLR C	
    SUBB A,HH
    JC A9

    MOV A,HH	
    CLR C
    SUBB A,ALMHH
    JZ A4

    MOV A,HH
    CLR C
    SUBB A,ALMHHOFF
    JZ A7

    SJMP A8		
A4:
    MOV A,MM	
    CLR C		
    SUBB A,ALMMM
    JC RETURN

    MOV A,MM	
    CLR C
    SUBB A,ALMMM
    JZ A10

    MOV A,HH	
    CLR C	
    SUBB A,ALMHHOFF
    JC A8

    MOV A,MM
    CLR C		
    SUBB A,ALMMMOFF
    JC A8

    MOV A,ALMMMOFF	
    CLR C		
    SUBB A,MM
    JC A9


    MOV A,SS	
    CLR C		
    SUBB A,ALMSSOFF
    JC A8

    SJMP A9	
A7:

    MOV A,MM	
    CLR C				
    SUBB A,ALMMMOFF
    JC A8

    MOV A,ALMMMOFF	
    CLR C		
    SUBB A,MM
    JC A9

    MOV A,SS	
    SUBB A,ALMSSOFF		
    JC A8

    SJMP A9	
		
A10:		
    MOV A,SS
    CLR C
    SUBB A,ALMSS
    JC RETURN

    MOV A,SS	
    CLR C			
    SUBB A,ALMSSOFF
    JC A8

    SJMP A9	
		

A8:
    SNDON
    SJMP RETURN

A9:
    SNDOFF
    
END

